## libwyliodrin 2.3-1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)

project (libwyliodrin)

set (CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG}   -Wall")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Wall")

# Appends the cmake/modules path to MAKE_MODULE_PATH variable.
set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})

# Dependencies
find_package (Threads)
find_package (SWIG)
if (SWIG_FOUND)
  include (${SWIG_USE_FILE})
endif ()
find_package (PkgConfig REQUIRED)
find_package (Hiredis REQUIRED)
include_directories (${HIREDIS_INCLUDE_DIR})
find_package (Jansson REQUIRED)
include_directories (${JANSSON_INCLUDE_DIR})
pkg_check_modules (EVENT REQUIRED libevent)

# Version
set (VERSION_MAJOR 2)
set (VERSION_MINOR 3)

# Configuration file
configure_file (
  "${PROJECT_SOURCE_DIR}/src/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
)

# Options
option (RASPBERRYPI "Build for the RaspberryPi."   OFF)
option (DEVICEINTEL     "Build for the Intel Galileo." OFF)
option (BEAGLEBONE  "Build for the Beaglebone."    OFF)
option (REDPITAYA   "Build for the RedPitaya."     OFF)
option (UDOONEO     "Build for the UDOO NEO."      OFF)
option (SERVER      "Build for the Server."        OFF)

# Option management
if (DEVICEINTEL)
  add_definitions (-DDEVICEINTEL)
  pkg_check_modules (MRAA REQUIRED mraa>=0.4.0)
  message (INFO "found libmraa version: ${MRAA_VERSION}")
  set(FLAGS "-DDEVICEINTEL")

elseif (MINNOWBOARDMAX)
  add_definitions(-DMINNOWBOARDMAX)
  pkg_check_modules (MRAA REQUIRED mraa>=0.4.0)
  message (INFO " found libmraa version: ${MRAA_VERSION}")
  set(FLAGS "-DMINNOWBOARDMAX")


elseif (RASPBERRYPI)
  add_definitions (-DRASPBERRYPI)
  find_package (Wiringpi REQUIRED)
  set (FLAGS "-DRASPBERRYPI")
  include_directories (${WIRINGPI_INCLUDE_DIR})

elseif (BEAGLEBONE)
  add_definitions (-DBEAGLEBONE)
  set (FLAGS "-DBEAGLEBONE")

elseif (REDPITAYA)
  add_definitions (-DREDPITAYA)
  find_package (rp REQUIRED)
  set (FLAGS "-DREDPITAYA")
  include_directories (${REDPITAYA_INCLUDE_DIR})

elseif (UDOONEO)
  add_definitions (-DUDOONEO)
  set(FLAGS "-DUDOONEO")

elseif (SERVER)
  add_definitions (-DSERVER)
  set(FLAGS "-DSERVER")

else ()
  message (FATAL_ERROR "You need to choose between -DRASPBERRYPI=ON, -DGALILEO=ON, -DEDISON=ON, -DBEAGLEBONE=ON, -DREDPITAYA=ON, -DUDOONEO=ON or -DSERVER=ON")
endif ()


add_definitions ("-Wall -DDEBUG -DSWIG_V8_VERSION=0x032873")

include_directories (${PROJECT_BINARY_DIR})

# Sources
set (wyliodrin_LIB_SRCS
  # Core
  ${PROJECT_SOURCE_DIR}/src/version.c
  ${PROJECT_SOURCE_DIR}/src/setup.c
  ${PROJECT_SOURCE_DIR}/src/wiring/BitsAndBytes.c
  ${PROJECT_SOURCE_DIR}/src/signals/signals.c
  ${PROJECT_SOURCE_DIR}/src/communication/communication.c
  ${PROJECT_SOURCE_DIR}/src/cmp/cmp.c
  ${PROJECT_SOURCE_DIR}/src/wiring/arduinogalileo.c
  ${PROJECT_SOURCE_DIR}/src/wiring/raspberrypi.c
  ${PROJECT_SOURCE_DIR}/src/wiring/server.c
  ${PROJECT_SOURCE_DIR}/src/wiring/i2c.c
  ${PROJECT_SOURCE_DIR}/src/wiring/math.c
  ${PROJECT_SOURCE_DIR}/src/wiring/beaglebone.c
  ${PROJECT_SOURCE_DIR}/src/wiring/beagleboneConfig.c
  ${PROJECT_SOURCE_DIR}/src/wiring/red-pitaya.c
  ${PROJECT_SOURCE_DIR}/src/wiring/udooneo.c

  # Auxiliary
  ${PROJECT_SOURCE_DIR}/src/libraries/lcd.c
  ${PROJECT_SOURCE_DIR}/src/libraries/Print.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/rgb_lcd.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Servo.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Stepper.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Stream.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Wire.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/WString.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/SPI.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_GFX.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_PCD8544.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_ST7735.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_LEDBackpack.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_Sensor.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_BMP085_U.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/Adafruit_MCP23008.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/SparkFun_APDS9960.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/LiquidCrystal.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/HTU21D.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/TM1637.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/SeeedOLED.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/I2Cdev.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/MPU6050.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/LED_Bar.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/CircularLED.cpp
  ${PROJECT_SOURCE_DIR}/src/libraries/UniPi.c
)

add_subdirectory (src)
add_subdirectory (languages)

add_subdirectory (wylio)

if (SERVER)
else ()
  install (FILES scripts/install_social      DESTINATION bin/ PERMISSIONS WORLD_READ WORLD_EXECUTE)
  install (FILES scripts/update_libwyliodrin DESTINATION bin/ PERMISSIONS WORLD_READ WORLD_EXECUTE)
  install (FILES scripts/update_streams      DESTINATION bin/ PERMISSIONS WORLD_READ WORLD_EXECUTE)
  install (FILES scripts/say                 DESTINATION bin/ PERMISSIONS WORLD_READ WORLD_EXECUTE)
endif ()

=== languages/CMakeLists.txt ===
add_subdirectory (python)
add_subdirectory (nodejs)

=== src/CMakeLists.txt ===
add_library (wyliodrin SHARED ${wyliodrin_LIB_SRCS})
target_link_libraries (wyliodrin ${HIREDIS_LIBRARIES} ${JANSSON_LIBRARIES} ${MRAA_LIBRARIES} ${WIRINGPI_LIBRARIES} ${REDPITAYA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} -lrt)

set_target_properties (
  wyliodrin
  PROPERTIES
  SOVERSION ${VERSION_MAJOR}
  VERSION ${VERSION_MINOR}
)

file (GLOB wyiliodrin_headers
  "communication/*.h"
  "signals/*.h"
  "libraries/*.h"
  "wiring/*.h"
  "cmp/cmp.h"
  "setup.h"
  "version.h"
)

install (TARGETS wyliodrin DESTINATION lib)
install (FILES Arduino.h Wyliodrin.h DESTINATION include/)
install (FILES ${wyiliodrin_headers} DESTINATION include/Wyliodrin/)

=== wylio/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)

project (wylio)

set (CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG}   -Wall")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Wall")

# Appends the cmake/modules path to MAKE_MODULE_PATH variable.
set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH})



# Dependencies
find_package (PkgConfig REQUIRED)
find_package (Hiredis REQUIRED)
include_directories (${HIREDIS_INCLUDE_DIR})
find_package (Jansson REQUIRED)
include_directories (${JANSSON_INCLUDE_DIR})
pkg_check_modules (EVENT REQUIRED libevent)


add_definitions ("-Wall -DDEBUG")


include_directories (${PROJECT_BINARY_DIR})



# Sources
set (wylio_SRCS
  # Core
  ${PROJECT_SOURCE_DIR}/wylio.c
)

add_executable (wylio
  ${wylio_SRCS}
)

target_link_libraries (wylio wyliodrin -levent) 



install (TARGETS wylio DESTINATION bin)

=== examples/beaglebone/Makefile ===
all: blink blinkUserLed bouncingBall policeSiren pulseRateMonitor
.PHONY: all

blink: blink.c
	gcc -Wall blink.c -o blink -lwyliodrin
.PHONY: blink

blinkUserLed: blinkUserLed.c
	gcc -Wall blinkUserLed.c -o blinkUserLed -lwyliodrin
.PHONY: blinkUserLed

bouncingBall: bouncingBall.c
	gcc -Wall bouncingBall.c -o bouncingBall -lwyliodrin
.PHONY: bouncingBall

policeSiren: policeSiren.c
	gcc -Wall policeSiren.c -o policeSiren -lwyliodrin
.PHONY: policeSiren

pulseRateMonitor: pulseRateMonitor.c
	gcc -Wall pulseRateMonitor.c -o pulseRateMonitor -lwyliodrin
.PHONY: pulseRateMonitor

clean:
	rm blink blinkUserLed bouncingBall policeSiren pulseRateMonitor
.PHONY: clean

=== languages/nodejs/CMakeLists.txt ===
find_path (NODE_ROOT_DIR "node/node.h" "nodejs/node.h")

set (NODE_INCLUDE_DIRS
  ${NODE_ROOT_DIR}/node
  ${NODE_ROOT_DIR}/nodejs
)

include_directories (
  ${NODE_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/src
)

set (CMAKE_CXX_FLAGS -DBUILDING_NODE_EXTENSION)

set_source_files_properties (wyliodrin.i PROPERTIES SWIG_FLAGS "-node;-I${CMAKE_BINARY_DIR}/src")
set_source_files_properties (wyliodrin.i PROPERTIES CPLUSPLUS ON)
swig_add_module (wyliodrinjs javascript wyliodrin.i  ${wyliodrin_LIB_SRCS})
swig_link_libraries (wyliodrinjs ${NODE_LIBRARIES} ${HIREDIS_LIBRARIES} ${JANSSON_LIBRARIES} ${WIRINGPI_LIBRARIES} ${MRAA_LIBRARIES} ${REDPITAYA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} -lrt -levent)

set_target_properties (wyliodrinjs PROPERTIES
  PREFIX ""
  OUTPUT_NAME "wyliodrin"
  SUFFIX ".node"
)

install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/package.json
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.node
         DESTINATION lib/node_modules/wyliodrin)

=== languages/python/CMakeLists.txt ===
FIND_PACKAGE (PythonLibs)
INCLUDE_DIRECTORIES (${PYTHON_INCLUDE_PATH})

include_directories (
  ${CMAKE_SOURCE_DIR}/src/
  ${PYTHON_INCLUDE_DIRS}
)

set_source_files_properties (wyliodrin.i PROPERTIES CPLUSPLUS ON)
set(SWIG_FLAGS "-I${CMAKE_SOURCE_DIR}/src" "${FLAGS}")
set_source_files_properties (wyliodrin.i PROPERTIES SWIG_FLAGS "${SWIG_FLAGS}")
swig_add_module (wyliodrin python wyliodrin.i ${wyliodrin_LIB_SRCS})
swig_link_libraries (wyliodrin ${PYTHON_LIBRARIES} ${HIREDIS_LIBRARIES} ${JANSSON_LIBRARIES} ${WIRINGPI_LIBRARIES} ${MRAA_LIBRARIES} ${REDPITAYA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} -lrt -levent)

# Essentially do seperate_arguments but with "." instead of " "
string (REPLACE "." ";" PYTHON_VERSION_LIST ${PYTHONLIBS_VERSION_STRING})
list (GET PYTHON_VERSION_LIST 0 PYTHON_VERSION_MAJOR)
list (GET PYTHON_VERSION_LIST 1 PYTHON_VERSION_MINOR)

if (GALILEO)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/)
elseif (EDISON)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/)
elseif (RASPBERRYPI)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/)
elseif (BEAGLEBONE)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/)
elseif (SERVER)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/)
elseif (REDPITAYA)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/)
elseif (UDOONEO)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/)
else ()
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/_wyliodrin.so
         ${CMAKE_CURRENT_BINARY_DIR}/wyliodrin.py
         DESTINATION lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/)
endif ()

=== debian/changelog ===
libwyliodrin (2.3-1) trusty; urgency=low

  * Initial release

 -- Razvan MATEI <matei.rm94@gmail.com>  Fri, 11 Mar 2016 09:39:52 +0000

=== debian/control ===
Source: libwyliodrin
Priority: optional
Maintainer: Razvan MATEI <matei.rm94@gmail.com>
Build-Depends: debhelper (>= 8.0.0), cmake
Standards-Version: 3.9.4
Section: libs
Homepage: https://wyliodrin.com
Vcs-Git: https://github.com/Wyliodrin/libwyliodrin.git
Vcs-Browser: https://github.com/Wyliodrin/libwyliodrin

Package: libwyliodrin-dev
Section: libdevel
Architecture: any
Depends: libwyliodrin (= ${binary:Version})
Description: libwyliodrin dev

Package: libwyliodrin
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libwyliodrin

## libwyliodrin 2.4-1

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
 
 # Version
 set (VERSION_MAJOR 2)
-set (VERSION_MINOR 3)
+set (VERSION_MINOR 4)
 
 # Configuration file
 configure_file (
@@ -33,7 +33,7 @@
 
 # Options
 option (RASPBERRYPI "Build for the RaspberryPi."   OFF)
-option (DEVICEINTEL     "Build for the Intel Galileo." OFF)
+option (DEVICEINTEL "Build for the Intel Galileo." OFF)
 option (BEAGLEBONE  "Build for the Beaglebone."    OFF)
 option (REDPITAYA   "Build for the RedPitaya."     OFF)
 option (UDOONEO     "Build for the UDOO NEO."      OFF)
@@ -42,6 +42,8 @@
 # Option management
 if (DEVICEINTEL)
   add_definitions (-DDEVICEINTEL)
+  add_definitions ("-DSWIG_V8_VERSION=0x040567")
+  add_definitions ("-std=c++11")
   pkg_check_modules (MRAA REQUIRED mraa>=0.4.0)
   message (INFO "found libmraa version: ${MRAA_VERSION}")
   set(FLAGS "-DDEVICEINTEL")
@@ -71,6 +73,8 @@
 
 elseif (UDOONEO)
   add_definitions (-DUDOONEO)
+  add_definitions ("-DSWIG_V8_VERSION=0x040655")
+  add_definitions ("-std=c++11")
   set(FLAGS "-DUDOONEO")
 
 elseif (SERVER)
@@ -81,8 +85,7 @@
   message (FATAL_ERROR "You need to choose between -DRASPBERRYPI=ON, -DGALILEO=ON, -DEDISON=ON, -DBEAGLEBONE=ON, -DREDPITAYA=ON, -DUDOONEO=ON or -DSERVER=ON")
 endif ()
 
-
-add_definitions ("-Wall -DDEBUG -DSWIG_V8_VERSION=0x032873")
+add_definitions ("-Wall -DDEBUG")
 
 include_directories (${PROJECT_BINARY_DIR})

=== examples/udooneo/Makefile ===
all: gpio
.PHONY: all

gpio: gpio.c
	gcc -Wall gpio.c -o gpio -lwyliodrin -levent
.PHONY: blink

clean:
	rm -r gpio
.PHONY: clean

=== languages/nodejs/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,9 @@
-find_path (NODE_ROOT_DIR "node/node.h" "nodejs/node.h")
+find_path (NODE_ROOT_DIR NAMES "node/node.h" "nodejs/node.h" "nodejs/src/node.h")
 
 set (NODE_INCLUDE_DIRS
   ${NODE_ROOT_DIR}/node
   ${NODE_ROOT_DIR}/nodejs
+  ${NODE_ROOT_DIR}/nodejs/src
 )
 
 include_directories (

=== debian/changelog ===
libwyliodrin (2.4-1) trusty; urgency=low

  * Add dependencies and change node version

 -- Razvan MATEI <matei.rm94@gmail.com>  Tue, 26 Apr 2016 09:39:52 +0000

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,10 @@
 Package: libwyliodrin-dev
 Section: libdevel
 Architecture: any
-Depends: libwyliodrin (= ${binary:Version})
+Depends: libwyliodrin (= ${binary:Version}), ${misc:Depends}, nodejs, libhiredis-dev, libevent-dev, python-dev, nodejs-dev, libi2c-dev, python-redis
 Description: libwyliodrin dev
 
 Package: libwyliodrin
-Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: libwyliodrin

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DUDOONEO=ON
